(*****************************************************************************)
(*                                                                           *)
(*                        ---  EXTREME.INC  ---                              *)
(*                                                                           *)
(*               Unterprogramm-Modul zur Extremwertberechung                 *)
(*                                                                           *)
(*****************************************************************************)


Procedure FindExtremeValues;


   Var x,dx,
       xmin,xmax :Real;
       found,
       Success   :Boolean;

   Begin
   ClrScr;
   WriteLn ('Extremwertbestimmung'); WriteLn;
   Write ('im Bereich von xmin='); Read (xmin);
   Write (' bis xmax='); Read (xmax);
   Write (' mit Schrittweite dx='); ReadLn (dx);
   WriteLn; WriteLn;
   found := false;
   x := Solve (xmin,xmax,dx,1,Success);
   If Success then
      Repeat
         If fn(x,2)<-eps then                                (* f"(x)<0? *)
            Write ('H')
         else
            if fn(x,2)>eps then                              (* f"(x)>0? *)
               Write ('T')
            else
               if (fn(x,3)>eps) or (fn(x,3)<-eps) then     (* f'"(x)<>0? *)
                  Write ('S')
               else
                  Success := false;
         If Success then
            Begin
            WriteLn (' (',x:m:n,', ',fn(x,0):m:n,')');
            found := true
            End;
         xmin := x + dx;
         x := Solve (xmin,xmax,dx,1,Success)            (* loese f'(x)=0 *)
      until not Success or (x>xmax);
   if not found then WriteLn ('Keine Extremwerte gefunden!')
   End;
