(*****************************************************************************)
(*                                                                           *)
(*                            ---  FLEX.INC  ---                             *)
(*                                                                           *)
(*               Unterprogramm-Modul zur Wendestellenberechnung              *)
(*                                                                           *)
(*****************************************************************************)


Procedure FindFlexPoints;


   Var x,dx,
       xmin,xmax :Real;
       found,
       Success   :Boolean;

   Begin
   ClrScr;
   WriteLn ('Wendestellenbestimmung'); WriteLn;
   Write ('im Bereich von xmin='); Read (xmin);
   Write (' bis xmax='); Read (xmax);
   Write (' mit Schrittweite dx='); ReadLn (dx);
   WriteLn; WriteLn;
   found := false;
   x := Solve (xmin,xmax,dx,2,Success);
   If Success then
      Repeat
         If (fn(x,3)<-eps) or (fn(x,3)>eps) then           (* f'"(x)<>0? *)
            If (fn(x,1)<eps) and (fn(x,1)>-eps) then         (* f'(x)=0? *)
               Write ('S')
            else
               Write ('W')
         else
            Success := false;
         If Success then
            Begin
            WriteLn (' (',x:m:n,', ',fn(x,0):m:n,')');
            found := true
            End;
         xmin := x + dx;
         x := Solve (xmin,xmax,dx,2,Success)            (* loese f"(x)=0 *)
      until not Success or (x>xmax);
   If not found then WriteLn ('Keine Wendestelle gefunden!')
   End;
